475. Heaters (start binary search, appplication for binary search)

Winter is coming! Your first job during the contest is to design a standard heater with fixed warm radius to warm all the houses.

Now, you are given positions of houses and heaters on a horizontal line, find out minimum radius of heaters so that all houses could be covered by those heaters.

So, your input will be the positions of houses and heaters seperately, and your expected output will be the minimum radius standard of heaters.

Note:
Numbers of houses and heaters you are given are non-negative and will not exceed 25000.
Positions of houses and heaters you are given are non-negative and will not exceed 10^9.
As long as a house is in the heaters' warm radius range, it can be warmed.
All the heaters follow your radius standard and the warm radius will the same.
Example 1:
Input: [1,2,3],[2]
Output: 1
Explanation: The only heater was placed in the position 2, and if we use the radius 1 standard, then all the houses can be warmed.
Example 2:
Input: [1,2,3,4],[1,4]
Output: 1
Explanation: The two heater was placed in the position 1 and 4. We need to use radius 1 standard, then all the houses can be warmed.

Solution: why we use binary search here, thr brute force search method is get max(min (dist)), to reduce time complexixity we need to use binary search(why), there are two elments(in heaters) close to the houses[i]

Here binary search model is to find first >= target. (basic model is 35 search insert poition

class Solution {
    //check houses, compare maxdist(min(house[i], heaters[j]) : min distance between house[i], heaters[j];   and get max of them; max(min(dist))
    public int findRadius(int[] houses, int[] heaters) {
        int radius = 0;//max
        Arrays.sort(heaters);
        for(int i = 0; i<houses.length; i++){
            int min = Integer.MAX_VALUE;
            //binary search (find first >= houses), target is houses[i]
            int l = 0, r = heaters.length-1;
            while(l <= r){
                int m = (r-l)/2 + l;
                if(heaters[m] >= houses[i]) r = m-1 ;
                else l = m+1;
            }
            //System.out.println(l);
            //l is the index, could be 0, >=heaters.length
            int d1 = l-1>=0 ? (houses[i] - heaters[l-1]) : Integer.MAX_VALUE; 
            int d2 = l<heaters.length ? (heaters[l] - houses[i]): Integer.MAX_VALUE;// handle all the things
            min = d1<d2 ? d1 : d2;
            if(min > radius) radius = min;
        }
        return radius;
    }
}

Another way : call built in function of binary search in the Arrays.binarySearch(); (https://docs.oracle.com/javase/7/docs/api/java/util/Arrays.html#binarySearch(int[],%20int)) https://www.geeksforgeeks.org/arrays-binarysearch-java-examples-set-1/(geekforgeek)

public class Solution {
    public int findRadius(int[] houses, int[] heaters) {
        Arrays.sort(heaters);
        int result = Integer.MIN_VALUE;
        
        for (int house : houses) {
            int index = Arrays.binarySearch(heaters, house);
            if (index < 0) {
            index = -(index + 1);
            }
            int dist1 = index - 1 >= 0 ? house - heaters[index - 1] : Integer.MAX_VALUE;
            int dist2 = index < heaters.length ? heaters[index] - house : Integer.MAX_VALUE;
        
            result = Math.max(result, Math.min(dist1, dist2));
        }
        
        return result;
    }
}

lastly, remember to sort first

 

35. search the insert position: find first index >= target

class Solution {
    public int searchInsert(int[] nums, int target) {
        int l = 0, r = nums.length-1;
        //find first larger element >= target (four cases)
        while(l<=r){//the last case is l==r and
            int m = (r-l)/2 + l;
            if(nums[m] >= target) r = m-1;//this one or before this one
            else l = m+1;//certain right
        }
        return l; } }

 

69. sqrt(x)

Implement int sqrt(int x).

Compute and return the square root of x, where x is guaranteed to be a non-negative integer.

Since the return type is an integer, the decimal digits are truncated and only the integer part of the result is returned.

Example 1:

Input: 4
Output: 2
Example 2:

Input: 8
Output: 2
Explanation: The square root of 8 is 2.82842..., and since 
             the decimal part is truncated, 2 is returned.

Solution: find last element's square <= x (recursive)........................... m <= x/m , look out for m = 0 case

m < x/m: could be this or right

m==x/m: this one

m > x/m: must be left(shift to left)

class Solution {
    public int mySqrt(int x) {//find frist ele ele^2 >= 8
        return bs(0,x, x);
    }
    int bs(int l, int r, int x){
        if(x < 1) return 0;
        if(x==1) return 1;
        if(l > r) return r;
        int m = (r-l)/2+l;
        if(m > x/m) return bs(l, m-1, x);
        else return bs(m+1, r,x);
        //return r;
    }
}

 

367 valid perfect square

Given a positive integer num, write a function which returns True if num is a perfect square else False.

Note: Do not use any built-in library function such as sqrt.

Example 1:

Input: 16
Returns: True
Example 2:

Input: 14
Returns: False

Solution: O(lgn), find the sqrt(x) firstly

class Solution {
    public boolean isPerfectSquare(int num) {
        //bs to get the num
        int l = 1, r = num;
        while(l<=r){
            int m = (r-l)/2 + l;
            if(m > num/m) r = m-1;
            else l = m+1;
        }
        return (r*r==num);
    }
}

 

转载于:https://www.cnblogs.com/stiles/p/leetcode457.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值